IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'TMP_REGISTRO_PRODUTO' AND
              TYPE   = 'U' 		 AND
              U.UID  = O.UID             AND
              U.NAME = USER)

DROP TABLE TMP_REGISTRO_PRODUTO
GO
CREATE TABLE TMP_REGISTRO_PRODUTO
(CDTIPOREG     VARCHAR(2) NOT NULL,
 CDARVPROD     VARCHAR(20) NOT NULL,
 DTINICIAL     DATETIME,
 DTFINAL       DATETIME,
 CDCLASFISC    VARCHAR(20),
 NMPRODUTO     VARCHAR(50),
 SGUNIDADE     VARCHAR(06),
 CDSITUTRIBPR  VARCHAR(3),
 VRALIQIPI     FLOAT,
 VRALIQICMS    FLOAT,
 VRPERREDBCIT  FLOAT,
 VRBASESUBST   FLOAT,
 CONSTRAINT PK_TMP_REGISTRO_PRODUTO PRIMARY KEY(CDTIPOREG, CDARVPROD))
GO

IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ARQUIVO_MAGNETICO' AND
              TYPE   = 'P' 		 AND
              U.UID  = O.UID             AND
              U.NAME = USER)

DROP PROCEDURE ARQUIVO_MAGNETICO
GO
CREATE PROCEDURE ARQUIVO_MAGNETICO
   @P_REGISTRO     VARCHAR(10),
   @P_CDIMPOSTO    VARCHAR(02),
   @P_CDEMPRESA    VARCHAR(02),
   @P_CDINSCESTA   VARCHAR(16),
   @P_DTINICIAL    DATETIME,
   @P_DTFINAL      DATETIME,
   @P_DTPOSICAO    DATETIME,
   @P_CDPAIS       VARCHAR(04),
   @P_SGESTADO     VARCHAR(02),
   @P_VERSAO       VARCHAR(04),
   @P_FINALIDADE   VARCHAR(01),
   @P_NRSEQARQMAG  VARCHAR(10),
   @P_LIVRO        VARCHAR(10),
   @P_INVENTARIO   VARCHAR(01),
   @P_GERAFORSALE  VARCHAR(01)
AS
   DECLARE @V_CONTADOR       NUMERIC;
   DECLARE @V_IPI            VARCHAR(02);
   DECLARE @V_GERAFORSALE    VARCHAR(1);
   DECLARE @V_CDSITUCRT      VARCHAR(01);

BEGIN
   SET @V_CONTADOR = 0;

   SELECT @V_IPI = CDIMPOSTOLIVRO
     FROM TPIMPOSLIVRO
    WHERE CDLIVROMAG = @P_LIVRO
      AND SGIMPOSTOLIVRO LIKE 'IPI';

   /*VERIFICA SE A EMPRESA  DO SIMPLES NACIONAL, '3' NAO  DO SIMPLES, APENAS 1 E 2*/
   SELECT @V_CDSITUCRT = ISNULL(MAX(CDSITUCRT), '3')
     FROM PARAMEMPRESA
    WHERE CDEMPRESA = @P_CDEMPRESA;

   IF @V_IPI IS NULL BEGIN
      SET @V_IPI = '10';
   END;
   IF @P_GERAFORSALE IS NULL BEGIN
      SET @V_GERAFORSALE = 'N';
   END;
   IF @P_GERAFORSALE IS NOT NULL BEGIN
      SET @V_GERAFORSALE = @P_GERAFORSALE;
   END;
-------------------------------REGISTRO CABECALHO-------------------------------

   EXEC TEKNISA.ARQUIVO_SINTEGRA_CABECALHO @P_CDEMPRESA,@P_CDIMPOSTO,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@P_NRSEQARQMAG,@P_FINALIDADE,@P_VERSAO,@P_CONTADOR = @V_CONTADOR OUTPUT;

-------------------------------REGISTRO 50--------------------------------------
   IF SUBSTRING(@P_REGISTRO,1,1) = 'S' BEGIN
      EXEC TEKNISA.ARQUIVO_SINTEGRA_50 @P_CDEMPRESA,@P_CDIMPOSTO,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@P_CDPAIS,@P_SGESTADO,@P_NRSEQARQMAG,@V_GERAFORSALE,@V_CDSITUCRT,@P_CONTADOR = @V_CONTADOR OUTPUT;
   END;
-------------------------------REGISTRO 51--------------------------------------
   IF SUBSTRING(@P_REGISTRO,2,1) = 'S' BEGIN
      EXEC TEKNISA.ARQUIVO_SINTEGRA_51 @P_CDEMPRESA,@P_CDIMPOSTO,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@P_CDPAIS,@P_SGESTADO,@V_IPI,@P_NRSEQARQMAG,@P_CONTADOR = @V_CONTADOR OUTPUT;
   END;
-------------------------------REGISTRO 53--------------------------------------
   IF SUBSTRING(@P_REGISTRO,3,1) = 'S' BEGIN
      EXEC TEKNISA.ARQUIVO_SINTEGRA_53 @P_CDEMPRESA,@P_CDIMPOSTO,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@P_CDPAIS,@P_SGESTADO,@P_NRSEQARQMAG,@V_CDSITUCRT, @P_CONTADOR = @V_CONTADOR OUTPUT;
   END;
-------------------------------REGISTRO 54--------------------------------------
   IF SUBSTRING(@P_REGISTRO,4,1) = 'S' BEGIN
      EXEC TEKNISA.ARQUIVO_SINTEGRA_54 @P_CDEMPRESA,@P_CDIMPOSTO,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@P_CDPAIS,@P_SGESTADO,@V_IPI,@P_NRSEQARQMAG,@V_GERAFORSALE,@V_CDSITUCRT,@P_CONTADOR = @V_CONTADOR OUTPUT;
   END;
-------------------------------REGISTRO 55--------------------------------------
   IF SUBSTRING(@P_REGISTRO,5,1) = 'S' BEGIN
      EXEC TEKNISA.ARQUIVO_SINTEGRA_55 @P_CDEMPRESA,@P_CDIMPOSTO,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@V_GERAFORSALE,@P_CONTADOR = @V_CONTADOR OUTPUT;
   END;
-------------------------------REGISTRO 60--------------------------------------
   IF SUBSTRING(@P_REGISTRO,6,1) = 'S' BEGIN
      EXEC TEKNISA.REGISTRO60_M_A_D_I_R_SINTEGRA @P_CDEMPRESA,@P_CDIMPOSTO,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@P_NRSEQARQMAG,@V_CDSITUCRT,@P_CONTADOR = @V_CONTADOR OUTPUT;
   END;
-------------------------------REGISTRO 61--------------------------------------
   IF SUBSTRING(@P_REGISTRO,7,1) = 'S' BEGIN
      EXEC TEKNISA.ARQUIVO_SINTEGRA_61 @P_CDEMPRESA,@P_CDIMPOSTO,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@P_NRSEQARQMAG,@V_GERAFORSALE,@P_CONTADOR = @V_CONTADOR OUTPUT;
   END;
-------------------------------REGISTRO 70--------------------------------------
   IF SUBSTRING(@P_REGISTRO,8,1) = 'S' BEGIN
      EXEC TEKNISA.ARQUIVO_SINTEGRA_70 @P_CDEMPRESA,@P_CDIMPOSTO,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@P_CDPAIS,@P_SGESTADO,@P_NRSEQARQMAG,@V_CDSITUCRT, @P_CONTADOR = @V_CONTADOR OUTPUT;
   END;
-------------------------------REGISTRO 74--------------------------------------
   IF SUBSTRING(@P_REGISTRO,9,1) = 'S' BEGIN
      EXEC TEKNISA.ARQUIVO_SINTEGRA_74 @P_CDEMPRESA,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@P_DTPOSICAO,@P_NRSEQARQMAG,@P_INVENTARIO,@P_CONTADOR = @V_CONTADOR OUTPUT;
   END;
-------------------------------REGISTRO 75--------------------------------------
   IF SUBSTRING(@P_REGISTRO,10,1) = 'S' BEGIN
      EXEC TEKNISA.ARQUIVO_SINTEGRA_75 @P_VERSAO,@P_NRSEQARQMAG,@P_CONTADOR = @V_CONTADOR OUTPUT;
   END;
-------------------------------REGISTRO 90--------------------------------------

   EXEC TEKNISA.ARQUIVO_SINTEGRA_90 @P_CDEMPRESA,@P_CDINSCESTA,@P_NRSEQARQMAG,@P_CONTADOR = @V_CONTADOR OUTPUT;
   DELETE FROM TMP_REGISTRO_PRODUTO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ARQUIVO_MAGNETICO','5.30.000';
GO

